﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Controls.Schedules;
using Epi_Flex.Core.Types;

namespace EpiFlexDispatcherMockup
{
    /// <summary>
    /// Epi-Flex Appointment based on Infragistics.Controls.Schedules.Appointment</summary>
    /// <remarks>
    /// The purpose of this class is to add additional properties to Infragistics' Appointment
    /// type to facilitate Dispatcher Scheduling for Epi-Flex.</remarks>   
    public class EpiFlexAppointment : BaseInfo
    {
        /// <summary>
        /// Creates a new Epi-Flex Appointment. </summary>
        public EpiFlexAppointment()
        {

        }

        #region Properties

        #region Description
        /// <summary>
        /// local variable _description
        /// </summary>
        private string _description;

        /// <summary>
        /// Identifies the Description property.
        /// </summary>		
        public string Description
        {
            get { return _description; }
            set
            {
                _description = value;
                OnPropertyChanged("Description");
            }
        }
        #endregion  //Description

        #region End

        /// <summary>
        /// local variable _end
        /// </summary>
        private DateTime _end = DateTime.Now;

        /// <summary>
        /// Identifies the End property.
        /// </summary>		
        public DateTime End
        {
            get { return _end; }
            set
            {
                _end = value;
                OnPropertyChanged("End");
            }
        }
        #endregion  //End

        #region EndTimeZoneId
        /// <summary>
        /// local variable _endTimeZoneId
        /// </summary>
        private string _endTimeZoneId = "Eastern Standard Time";

        /// <summary>
        /// Identifies the EndTimeZoneId property.
        /// </summary>		
        public string EndTimeZoneId
        {
            get { return _endTimeZoneId; }
            set
            {
                _endTimeZoneId = value;
                OnPropertyChanged("EndTimeZoneId");
            }
        }
        #endregion  //EndTimeZoneId

        #region Id
        /// <summary>
        /// local variable _id
        /// </summary>
        private string _id;

        /// <summary>
        /// Identifies the Id property.
        /// </summary>		
        public string Id
        {
            get { return _id; }
            set
            {
                _id = value;
                OnPropertyChanged("Id");
            }
        }
        #endregion  //Id

        #region IsLocked
        /// <summary>
        /// local variable _myVar
        /// </summary>
        private Nullable<bool> _isLocked = false;

        /// <summary>
        /// Identifies the IsLocked property.
        /// </summary>		
        public Nullable<bool> IsLocked
        {
            get { return _isLocked; }
            set
            {
                _isLocked = value;
                OnPropertyChanged("IsLocked");
            }
        }
        #endregion  //IsLocked

        #region IsOccurrenceDeleted
        /// <summary>
        /// local variable _isOccurrenceDeleted
        /// </summary>
        private Nullable<bool> _isOccurrenceDeleted = false;

        /// <summary>
        /// Identifies the IsOccurrenceDeleted property.
        /// </summary>		
        public Nullable<bool> IsOccurrenceDeleted
        {
            get { return _isOccurrenceDeleted; }
            set
            {
                _isOccurrenceDeleted = value;
                OnPropertyChanged("IsOccurrenceDeleted");
            }
        }
        #endregion  //IsOccurrenceDeleted

        #region IsTimeZoneNeutral
        /// <summary>
        /// local variable _isTimeZoneNeutral
        /// </summary>
        private Nullable<bool> _isTimeZoneNeutral = true;

        /// <summary>
        /// Identifies the IsTimeZoneNeutral property.
        /// </summary>		
        public Nullable<bool> IsTimeZoneNeutral
        {
            get { return _isTimeZoneNeutral; }
            set
            {
                _isTimeZoneNeutral = value;
                OnPropertyChanged("IsTimeZoneNeutral");
            }
        }
        #endregion  //IsTimeZoneNeutral

        #region IsVisible
        /// <summary>
        /// local variable _isVisible
        /// </summary>
        private Nullable<bool> _isVisible = true;

        /// <summary>
        /// Identifies the IsVisible property.
        /// </summary>		
        public Nullable<bool> IsVisible
        {
            get { return _isVisible; }
            set
            {
                _isVisible = value;
                OnPropertyChanged("IsVisible");
            }
        }
        #endregion  //IsVisible

        #region IsHoliday
        /// <summary>
        /// local variable _isHoliday
        /// </summary>
        private Nullable<bool> _isHoliday = false;

        /// <summary>
        /// Identifies the IsHoliday property.
        /// </summary>		
        public Nullable<bool> IsHoliday
        {
            get { return _isHoliday; }
            set
            {
                _isHoliday = value;
                OnPropertyChanged("IsHoliday");
            }
        }
        #endregion  //IsHoliday

        #region IsEndOfMarkingPeriod
        /// <summary>
        /// local variable _isEndOfMarkingPeriod
        /// </summary>
        private Nullable<bool> _isEndOfMarkingPeriod = false;

        /// <summary>
        /// Identifies the IsEndOfMarkingPeriod property.
        /// </summary>		
        public Nullable<bool> IsEndOfMarkingPeriod
        {
            get { return _isEndOfMarkingPeriod; }
            set
            {
                _isEndOfMarkingPeriod = value;
                OnPropertyChanged("IsEndOfMarkingPeriod");
            }
        }
        #endregion  //IsEndOfMarkingPeriod

        #region Location
        /// <summary>
        /// local variable _location
        /// </summary>
        private string _location;

        /// <summary>
        /// Identifies the Location property.
        /// </summary>		
        public string Location
        {
            get { return _location; }
            set
            {
                _location = value;
                OnPropertyChanged("Location");
            }
        }
        #endregion  //Location

        #region MaxOccurrenceDateTime
        /// <summary>
        /// local variable _mxOccurrenceDateTime
        /// </summary>
        private Nullable<DateTime> _mxOccurrenceDateTime;

        /// <summary>
        /// Identifies the MaxOccurrenceDateTime property.
        /// </summary>		
        public Nullable<DateTime> MaxOccurrenceDateTime
        {
            get { return _mxOccurrenceDateTime; }
            set
            {
                _mxOccurrenceDateTime = value;
                OnPropertyChanged("MaxOccurrenceDateTime");
            }
        }
        #endregion  //MaxOccurrenceDateTime

        #region OriginalOccurrenceEnd

        /// <summary>
        /// local variable _originalOccurrenceEnd
        /// </summary>
        private Nullable<DateTime> _originalOccurrenceEnd; // = DateTime.Now;

        /// <summary>
        /// Identifies the OriginalOccurrenceEnd property.
        /// </summary>		
        public Nullable<DateTime> OriginalOccurrenceEnd
        {
            get { return _originalOccurrenceEnd; }
            set
            {
                _originalOccurrenceEnd = value;
                OnPropertyChanged("OriginalOccurrenceEnd");
            }
        }
        #endregion  //OriginalOccurrenceEnd

        #region OriginalOccurrenceStart

        /// <summary>
        /// local variable _originalOccurrenceStart
        /// </summary>
        private Nullable<DateTime> _originalOccurrenceStart; // = DateTime.Now;

        /// <summary>
        /// Identifies the OriginalOccurrenceStart property.
        /// </summary>		
        public Nullable<DateTime> OriginalOccurrenceStart
        {
            get { return _originalOccurrenceStart; }
            set
            {
                _originalOccurrenceStart = value;
                OnPropertyChanged("OriginalOccurrenceStart");
            }
        }
        #endregion  //OriginalOccurrenceStart

        #region OwningCalendarId
        /// <summary>
        /// local variable _owningCalendarId
        /// </summary>
        private string _owningCalendarId;

        /// <summary>
        /// Identifies the OwningCalendarId property.
        /// </summary>		
        public string OwningCalendarId
        {
            get { return _owningCalendarId; }
            set
            {
                _owningCalendarId = value;
                OnPropertyChanged("OwningCalendarId");
            }
        }
        #endregion  //OwningCalendarId

        #region OwningResourceId
        /// <summary>
        /// local variable _owningResourceId
        /// </summary>
        private string _owningResourceId;

        /// <summary>
        /// Identifies the OwningResourceId property.
        /// </summary>		
        public string OwningResourceId
        {
            get { return _owningResourceId; }
            set
            {
                _owningResourceId = value;
                OnPropertyChanged("OwningResourceId");
            }
        }
        #endregion  //OwningResourceId

        #region Recurrence
        /// <summary>
        /// local variable _recurrence
        /// </summary>
        private string _recurrence = "";

        /// <summary>
        /// Identifies the Recurrence property.
        /// </summary>		
        public string Recurrence
        {
            get { return _recurrence; }
            set
            {
                _recurrence = value;
                OnPropertyChanged("Recurrence");
            }
        }
        #endregion  //Recurrence

        #region RecurrenceVersion
        /// <summary>
        /// local variable _recurrenceVersion
        /// </summary>
        private Nullable<int> _recurrenceVersion;

        /// <summary>
        /// Identifies the RecurrenceVersion property.
        /// </summary>		
        public Nullable<int> RecurrenceVersion
        {
            get { return _recurrenceVersion; }
            set
            {
                _recurrenceVersion = value;
                OnPropertyChanged("RecurrenceVersion");
            }
        }
        #endregion  //RecurrenceVersion

        #region Reminder
        /// <summary>
        /// local variable _reminder
        /// </summary>
        private string _reminder = "";

        /// <summary>
        /// Identifies the Reminder property.
        /// </summary>		
        public string Reminder
        {
            get { return _reminder; }
            set
            {
                _reminder = value;
                OnPropertyChanged("Reminder");
            }
        }
        #endregion  //Reminder

        #region ReminderEnabled
        /// <summary>
        /// local variable _reminderEnabled
        /// </summary>
        private Nullable<bool> _reminderEnabled = false;

        /// <summary>
        /// Identifies the ReminderEnabled property.
        /// </summary>		
        public Nullable<bool> ReminderEnabled
        {
            get { return _reminderEnabled; }
            set
            {
                _reminderEnabled = value;
                OnPropertyChanged("ReminderEnabled");
            }
        }
        #endregion  //ReminderEnabled

        #region ReminderInterval
        /// <summary>
        /// local variable _ReminderInterval
        /// </summary>
        private Nullable<TimeSpan> _reminderInterval;

        /// <summary>
        /// Identifies the ReminderInterval property.
        /// </summary>		
        public Nullable<TimeSpan> ReminderInterval
        {
            get { return _reminderInterval; }
            set
            {
                _reminderInterval = value;
                OnPropertyChanged("ReminderInterval");
            }
        }
        #endregion  //ReminderInterval

        #region RootActivityId
        /// <summary>
        /// local variable _rootActivityId
        /// </summary>
        private string _rootActivityId;

        /// <summary>
        /// Identifies the RootActivityId property.
        /// </summary>		
        public string RootActivityId
        {
            get { return _rootActivityId; }
            set
            {
                _rootActivityId = value;
                OnPropertyChanged("RootActivityId");
            }
        }
        #endregion  //RootActivityId

        #region Start

        /// <summary>
        /// local variable _start
        /// </summary>
        private DateTime _start = DateTime.Now;

        /// <summary>
        /// Identifies the Start property.
        /// </summary>		
        public DateTime Start
        {
            get { return _start; }
            set
            {
                _start = value;
                OnPropertyChanged("Start");
            }
        }
        #endregion  //Start

        #region StartTimeZoneId
        /// <summary>
        /// local variable _startTimeZoneId
        /// </summary>
        private string _startTimeZoneId = "Eastern Standard Time";

        /// <summary>
        /// Identifies the StartTimeZoneId property.
        /// </summary>		
        public string StartTimeZoneId
        {
            get { return _startTimeZoneId; }
            set
            {
                _startTimeZoneId = value;
                OnPropertyChanged("StartTimeZoneId");
            }
        }
        #endregion  //StartTimeZoneId

        #region Subject
        /// <summary>
        /// local variable _myVar
        /// </summary>
        private string _subject;

        /// <summary>
        /// Identifies the Subject property.
        /// </summary>		
        public string Subject
        {
            get { return _subject; }
            set
            {
                _subject = value;
                OnPropertyChanged("Subject");
            }
        }
        #endregion  //Subject

        #region UnmappedProperties
        /// <summary>
        /// local variable _unmappedProperties
        /// </summary>
        private string _unmappedProperties;

        /// <summary>
        /// Identifies the UnmappedProperties property.
        /// </summary>		
        public string UnmappedProperties
        {
            get { return _unmappedProperties; }
            set
            {
                _unmappedProperties = value;
                OnPropertyChanged("UnmappedProperties");
            }
        }
        #endregion  //UnmappedProperties

        #region VariantProperties
        /// <summary>
        /// local variable _variantProperties
        /// </summary>
        private Nullable<long> _variantProperties;

        /// <summary>
        /// Identifies the VariantProperties property.
        /// </summary>		
        public Nullable<long> VariantProperties
        {
            get { return _variantProperties; }
            set
            {
                _variantProperties = value;
                OnPropertyChanged("VariantProperties");
            }
        }
        #endregion  //VariantProperties 

        #region DrivingTime
        /// <summary>
        /// Store for the DrivingTime property.</summary>
        private TimeSpan _DrivingTime;
        /// <summary>
        /// Driving Time required to reach this appointment. </summary>
        public TimeSpan DrivingTime
        {
            get { return _DrivingTime; }
            set { _DrivingTime = value; }
        }
        #endregion //DrivingTime

        #region Mileage
        /// <summary>
        /// Store for the Mileage property.</summary>
        private Int32 _Mileage;
        /// <summary>
        /// Mileage to this appointment.</summary>
        public Int32 Mileage
        {
            get { return _Mileage; }
            set { _Mileage = value; }
        }
        #endregion //Mileage

        #region PromiseTimeStart
        /// <summary>
        /// Store for the PromiseTimeStart property.</summary>
        private DateTime _PromiseTimeStart;
        /// <summary>
        /// Earliest time promised to the customer. </summary>
        public DateTime PromiseTimeStart
        {
            get { return _PromiseTimeStart; }
            set { _PromiseTimeStart = value; }
        }
        #endregion //PromiseTimeStart

        #region PromiseTimeEnd
        /// <summary>
        /// Store for the PromiseTimeEnd property.</summary>
        private DateTime _PromiseTimeEnd;
        /// <summary>
        /// Latest time promised to the customer. </summary>
        public DateTime PromiseTimeEnd
        {
            get { return _PromiseTimeEnd; }
            set { _PromiseTimeEnd = value; }
        }
        #endregion //PromiseTimeEnd

        #endregion //Properties

        ///// <summary>
        ///// Description for SomeMethod.</summary>
        ///// <param name="FirstParam"> Parameter description for FirstParam goes here.</param>
        //public void SomeMethod(string FirstParam)
        //{
            
        //}

    }
}
